﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Configuration.aspx.cs" Inherits="Configuration" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Configuration</title>
    <link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>

    <form id="form1" runat="server" visible="True">
        <h1>Time Stamp Server - Configuration</h1>
                <p>
            <asp:Label ID="LabelError" runat="server" ForeColor="Red" 
                style="font-weight: 700"></asp:Label>
        </p>
        <p>
            <asp:Label ID="LabelInfo" runat="server"></asp:Label>
        </p>
        <hr/> 
        
    <h2>Timestamping Digital Certificate</h2>
    <p>
        <asp:Label ID="LabelInfoCertificate" runat="server"></asp:Label>
    </p>
            <p>
                <asp:Button ID="ButtonSelectTSACertificate" runat="server" 
                    onclick="ButtonSelectTSACertificate_Click" Text="Select the Digital Certificate" />
                &nbsp;&nbsp;
                <asp:Button ID="ButtonSelectTSACertificate0" runat="server" 
                    onclick="ButtonCreateCertificate_Click" 
                    Text="Create New Certificate" />
                <br /></p>
                <p>The Time Stamp Responses must be digitally signed by a Timestamping digital certificate</p>
    <hr/>
    <h2>Settings</h2>

        <p>
            <strong>Time Stamp Response Hash Algorithm:</strong>
            <asp:DropDownList ID="DropDownListHashAlgorithm" runat="server">
                <asp:ListItem>The same as on the Time Stamp Request</asp:ListItem>
                <asp:ListItem>SHA-1</asp:ListItem>
                <asp:ListItem>SHA-256</asp:ListItem>
                <asp:ListItem>SHA-512</asp:ListItem>
            </asp:DropDownList>
        </p>
            <p><b>*Time Stamp Server Policy ID:</b>
            <asp:TextBox ID="TextBoxTSAPolicyOID" runat="server" Width="210px">1.3.6.1.4.1.13762.3</asp:TextBox> &nbsp;(the default value is 
                1.3.6.1.4.1.13762.3. See <a href="https://tools.ietf.org/html/rfc3161" target="_blank">RFC 3161</a> for more details) <br />
                The policy field MUST indicate the Time Stamp Server policy under which the response was produced.     
        </p>
            <p>     
                <asp:CheckBox ID="CheckBoxRejectRequestsWithDifferentPolicyID" 
                    runat="server" 
                    Text="Time Stamp Request must include the current Time Stamp Server Policy ID" 
                    style="font-weight: 700" />
        </p>
            <p>
                <asp:CheckBox ID="CheckBoxSetOrdering" runat="server" 
                    Text="Set Ordering to True" style="font-weight: 700" />
        &nbsp;(if the ordering field is present and set to true, every time stamp can 
                always be ordered regardless of the accuracy).</p>
            <p>
                <asp:CheckBox ID="CheckBoxRequireNonce" runat="server" 
                    Text="Time Stamp Request must include a Nonce extension" 
                    style="font-weight: 700" />
        &nbsp;(using a nonce always allows to detect replays. The Request is rejected if it not contains a Nonce and this checkbox is checked).</p>
            <p>
                <asp:CheckBox ID="CheckBoxIncludeWholeChain" runat="server" 
                    Text="Include whole chain on the Time Stamp Response" 
                    style="font-weight: 700" />
                &nbsp;(the Time Stamp Response size will increase if the certificate chain is 
                included).</p>
        <p>
                <asp:CheckBox ID="CheckBoxEssCertId" runat="server" 
                    Text="Include ESSCertIDv2 attribute" 
                    style="font-weight: 700" />
                &nbsp;(include ESSCertID or ESSCertIDv2 according to <a href="https://tools.ietf.org/html/rfc5816" target="_blank">RFC 5816</a>).</p>
        <p>
                <asp:CheckBox ID="CheckBoxNotEncodeAsBase64" runat="server" 
                    Text="Do not encode Authenticode responses as BASE64" 
                    style="font-weight: 700" />
                &nbsp;(the Authenticode responses are usually encoded in BASE64).</p>
            <p>
                <asp:CheckBox ID="CheckBoxSetAccuracy" runat="server" 
                    Text="Set Accuracy" AutoPostBack="True" 
                    oncheckedchanged="CheckBoxAccuracy_CheckedChanged" 
                    style="font-weight: 700" />
        &nbsp;(by adding the accuracy value, an upper limit of the time at which the Time Stamp 
                Response has been created by the Time Stamp Server can be obtained).</p>
            <p>
                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <asp:TextBox ID="TextBoxSecs" runat="server" MaxLength="3" Width="50px" Enabled="False">0</asp:TextBox> Seconds&nbsp;&nbsp;
                <asp:TextBox ID="TextBoxMillis" runat="server" MaxLength="3" Width="50px" 
                    Enabled="False">0</asp:TextBox> Milliseconds&nbsp;&nbsp;
                <asp:TextBox ID="TextBoxMicros" runat="server" MaxLength="3" Width="50px" 
                    Enabled="False">0</asp:TextBox> Microseconds</p>
                        <hr/>
    <h2>Authentication</h2>
      <p>
          <asp:CheckBox ID="CheckBoxAuthentication" runat="server" AutoPostBack="True" 
              oncheckedchanged="CheckBoxAuthentication_CheckedChanged" style="font-weight: 700" 
              
              
              Text="Only authenticated users can obtain a Time Stamp Response from this server" />
          <br />
If this checkbox is not checked, the Time Stamp Server will always send the Time 
          Stamp Response for 
          every Time Stamp Request.</p>
            <p>
                <asp:Button ID="ButtonTSAUsers" runat="server" 
                    onclick="ButtonManageTSAUsers_Click" Text="Manage Users" 
                    Enabled="False" />
                <br /></p>
        <hr />
          <h2>Time Stamp Responses Log</h2>
        <p>
          <asp:CheckBox ID="CheckBoxLogAllTSAResponses" runat="server" Text="Log all the Time Stamp Responses issued by the Time Stamp Server. The log will contain info like Serial Number, issuing UTC time, Timestamping certificate" />
		</p>

                  &nbsp;<asp:Button ID="ButtonDownloadTSAResponseLog" runat="server" Text="Download the Time Stamp Responses Log" OnClick="ButtonDownloadTSAResponseLog_Click" />
  <p>The log file will be downloaded in CSV format.</p>
<hr />

             <asp:Button ID="ButtonBack" runat="server" Text="Main Page" 
            onclick="ButtonBack_Click" />
&nbsp;&nbsp;
        <asp:Button ID="ButtonSaveConfig" runat="server" Text="Save Configuration" Width="149px" onclick="ButtonSaveConfig_Click" />
    &nbsp;&nbsp;
        <asp:Button ID="ButtonRestoreDefaults" runat="server" 
            onclick="ButtonRestoreDefaults_Click" Text="Restore Defaults" Width="141px" />
            &nbsp;&nbsp;
        <asp:Button ID="ButtonRunTest" runat="server" onclick="ButtonRunTest_Click" 
            Text="Run a Test" />
            &nbsp;&nbsp;
        <asp:Button ID="ButtonLogout" runat="server" Text="Logout" 
            onclick="ButtonLogout_Click" Visible="False" />
    </form>
    <br />
</body>
</html>
